;============================================================
;
; DIS386 tables 
; Copyright (c) 1992-2003,2004 Alessandro Scotti
; http://www.ascotti.org/
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
; 31 Mar 1993 (A. Scotti):
;       updated with 486 instructions;
; 12 Aug 1994 (A. Scotti):
;       updated with Pentium instruction (some is missing);
;       changed _NULL registers to non-empty strings prefixed by '?'
; 25 Aug 1994 (A. Scotti):
;       all new Pentium opcodes added;
;       removed OT_A for OT_Q (altough neither is actually used)
;
;============================================================
RADIX   10

;------------------------------------------------------------
;
; String terminators
;
_0      EQU     '0' OR 128
_1      EQU     '1' OR 128
_2      EQU     '2' OR 128
_3      EQU     '3' OR 128
_4      EQU     '4' OR 128
_5      EQU     '5' OR 128
_6      EQU     '6' OR 128
_7      EQU     '7' OR 128
_8      EQU     '8' OR 128
_9      EQU     '9' OR 128
;
_A      EQU     'a' OR 128
_B	EQU	'b' OR 128
_C	EQU	'c' OR 128
_D	EQU	'd' OR 128
_E	EQU	'e' OR 128
_F	EQU	'f' OR 128
_G	EQU	'g' OR 128
_H	EQU	'h' OR 128
_I	EQU	'i' OR 128
_J	EQU	'j' OR 128
_K	EQU	'k' OR 128
_L	EQU	'l' OR 128
_M	EQU	'm' OR 128
_N	EQU	'n' OR 128
_O	EQU	'o' OR 128
_P	EQU	'p' OR 128
_Q	EQU	'q' OR 128
_R	EQU	'r' OR 128
_S	EQU	's' OR 128
_T	EQU	't' OR 128
_U	EQU	'u' OR 128
_V	EQU	'v' OR 128
_W	EQU	'w' OR 128
_X	EQU	'x' OR 128
_Y	EQU	'y' OR 128
_Z	EQU	'z' OR 128
;
_SPC    EQU     ' ' OR 128
_NULL   EQU     128

;------------------------------------------------------------
;
; Mnemonic instructions reference codes
;
N_AAA           EQU     0
N_AAD           EQU     1
N_AAM           EQU     2
N_AAS           EQU     3
N_ADC           EQU     4
N_ADD           EQU     5
N_AND           EQU     6
N_ARPL          EQU     7
N_BOUND         EQU     8
N_BSF           EQU     9
N_BSR           EQU     10
N_BT            EQU     11
N_BTC           EQU     12
N_BTR           EQU     13
N_BTS           EQU     14
N_CALL          EQU     15
N_CBW           EQU     16
N_CDQ           EQU     17
N_CLC           EQU     18
N_CLD           EQU     19
N_CLI           EQU     20
N_CLTS          EQU     21
N_CMC           EQU     22
N_CMP           EQU     23
N_CMPSB         EQU     24
N_CMPSD         EQU     25
N_CMPSW         EQU     26
N_CWD           EQU     27
N_CWDE          EQU     28
N_DAA           EQU     29
N_DAS           EQU     30
N_DEC           EQU     31
N_DIV           EQU     32
N_ENTER         EQU     33
;
N_HLT           EQU     34
N_IDIV          EQU     35
N_IMUL          EQU     36
N_IN            EQU     37
N_INC           EQU     38
N_INSB          EQU     39
N_INSD          EQU     40
N_INSW          EQU     41
N_INT           EQU     42
N_INTO          EQU     43
N_IRETD         EQU     44
N_IRET          EQU     45
N_JA            EQU     46
N_JAE           EQU     47
N_JB            EQU     48
N_JBE           EQU     49
N_JC            EQU     50
N_JCXZ          EQU     51
N_JE            EQU     52
N_JECXZ         EQU     53
N_JG            EQU     54
N_JGE           EQU     55
N_JL            EQU     56
N_JLE           EQU     57
N_JMP           EQU     58
N_JNC           EQU     59
N_JNE           EQU     60
N_JNO           EQU     61
N_JNP           EQU     62
N_JNS           EQU     63
N_JO            EQU     64
N_JP            EQU     65
N_JS            EQU     66
;
N_LAHF          EQU     67
N_LAR           EQU     68
N_LDS           EQU     69
N_LEA           EQU     70
N_LEAVE         EQU     71
N_LES           EQU     72
N_LFS           EQU     73
N_LGDT          EQU     74
N_LGS           EQU     75
N_LIDT          EQU     76
N_LLDT          EQU     77
N_LMSW          EQU     78
N_LOCK          EQU     79
N_LODSB         EQU     80
N_LODSD         EQU     81
N_LODSW         EQU     82
N_LOOP          EQU     83
N_LOOPE         EQU     84
N_LOOPNE        EQU     85
N_LSL           EQU     86
N_LSS           EQU     87
N_LTR           EQU     88
N_MOV           EQU     89
N_MOVSB         EQU     90
N_MOVSD         EQU     91
N_MOVSW         EQU     92
N_MOVSX         EQU     93
N_MOVZX         EQU     94
N_MUL           EQU     95
N_NEG           EQU     96
N_NOP           EQU     97
N_NOT           EQU     98
N_OR            EQU     99
N_OUT           EQU     100
N_OUTSB         EQU     101
N_OUTSD         EQU     102
N_OUTSW         EQU     103
;
N_POP           EQU     104
N_POPAD         EQU     105
N_POPA          EQU     106
N_POPFD         EQU     107
N_POPF          EQU     108
N_PUSH          EQU     109
N_PUSHAD        EQU     110
N_PUSHA         EQU     111
N_PUSHFD        EQU     112
N_PUSHF         EQU     113
N_RCL           EQU     114
N_RCR           EQU     115
N_REP           EQU     116
N_REPE          EQU     117
N_REPNE         EQU     118
N_RET           EQU     119
N_ROL           EQU     120
N_ROR           EQU     121
N_SAHF          EQU     122
N_SAR           EQU     123
N_SBB           EQU     124
N_SCASB         EQU     125
N_SCASD         EQU     126
N_SCASW         EQU     127
N_SETA          EQU     128
N_SETAE         EQU     129
N_SETB          EQU     130
N_SETBE         EQU     131
N_SETC          EQU     132
N_SETE          EQU     133
N_SETG          EQU     134
N_SETGE         EQU     135
N_SETL          EQU     136
N_SETLE         EQU     137
N_SETNC         EQU     138
N_SETNE         EQU     139
N_SETNO         EQU     140
N_SETNP         EQU     141
N_SETNS         EQU     142
N_SETO          EQU     143
N_SETP          EQU     144
N_SETS          EQU     145
;
N_SGDT          EQU     146
N_SHL           EQU     147
N_SHLD          EQU     148
N_SHR           EQU     149
N_SHRD          EQU     150
N_SIDT          EQU     151
N_SLDT          EQU     152
N_SMSW          EQU     153
N_STC           EQU     154
N_STD           EQU     155
N_STI           EQU     156
N_STOSB         EQU     157
N_STOSD         EQU     158
N_STOSW         EQU     159
N_STR           EQU     160
N_SUB           EQU     161
N_TEST          EQU     162
N_VERR          EQU     163
N_VERW          EQU     164
N_WAIT          EQU     165
N_XCHG          EQU     166
N_XLAT          EQU     167
N_XOR           EQU     168
;
N_RETF          EQU     169
N_DB            EQU     170
N_INT3          EQU     171
N_LOOPD         EQU     172
N_LOOPDE        EQU     173
N_LOOPDNE       EQU     174
N_LOADALL       EQU     175
; 486
N_BSWAP         EQU     176
N_CMPXCHG       EQU     177
N_INVD          EQU     178
N_INVLPG        EQU     179
N_WBINVD        EQU     180
N_XADD          EQU     181
; Pentium
N_CPUID         EQU     182             ; CPU IDentification (also on 486/DX2)
N_RDTSC         EQU     183             ; ReaD Time Stamp Counter
N_RDMSR         EQU     184             ; ReaD Model Specific Register
N_WRMSR         EQU     185             ; WRite Model Specific Register
N_RSM           EQU     186             ; Resume from System Management mode
N_CMPXCHG8B     EQU     187             ; CoMPare and eXCHanGe 8 Bytes
;
N_LALC          EQU     188             ; Undoc.: copy Carry into AL
;
N_NULL          EQU     255

;------------------------------------------------------------
;
; Codes for addressing method
;
AM_A    EQU     00000000b       ; Direct address
AM_C    EQU     00000001b       ; Control register from MODRM "reg" field
AM_D    EQU     00000010b       ; Debug register from MODRM "reg" field
AM_E    EQU     00000011b       ; MODRM
AM_G    EQU     00000100b       ; General register from MODRM "reg" field
AM_I    EQU     00000101b       ; Immediate data
AM_J    EQU     00000110b       ; Relative offset
AM_M    EQU     00000111b       ; MODRM may refer only to a memory location
AM_O    EQU     00001000b       ; Offset
AM_R    EQU     00001001b       ; MODRM "mod" field must specify a general reg.
AM_S    EQU     00001010b       ; Segment register from MODRM "reg" field
AM_T    EQU     00001011b       ; Test register from MODRM "reg" field
; 1100b, 1101b, 1110b, 1111b available for extensions

;------------------------------------------------------------
;
; Codes for operand type
;
OT_Q    EQU     00000000b       ; Eight bytes
OT_B    EQU     00010000b       ; Byte
OT_C    EQU     00100000b       ; Byte or word
OT_D    EQU     00110000b       ; Double word
OT_P    EQU     01000000b       ; 32-bit or 48-bit pointer
OT_S    EQU     01010000b       ; Six bytes
OT_V    EQU     01100000b       ; Word or dword
OT_W    EQU     01110000b       ; Word

;------------------------------------------------------------
;
; Codes for registers
;
R_AL    EQU     10000000b
R_CL    EQU     10000001b
R_DL    EQU     10000010b
R_BL    EQU     10000011b
R_AH    EQU     10000100b
R_CH    EQU     10000101b
R_DH    EQU     10000110b
R_BH    EQU     10000111b
;
R_AX    EQU     10001000b
R_CX    EQU     10001001b
R_DX    EQU     10001010b
R_BX    EQU     10001011b
R_SP    EQU     10001100b
R_BP    EQU     10001101b
R_SI    EQU     10001110b
R_DI    EQU     10001111b
;
R_EAX   EQU     10010000b
R_ECX   EQU     10010001b
R_EDX   EQU     10010010b
R_EBX   EQU     10010011b
R_ESP   EQU     10010100b
R_EBP   EQU     10010101b
R_ESI   EQU     10010110b
R_EDI   EQU     10010111b
;
R_ES    EQU     10011000b
R_CS    EQU     10011001b
R_SS    EQU     10011010b
R_DS    EQU     10011011b
R_FS    EQU     10011100b
R_GS    EQU     10011101b
;
R_1     EQU     10110000b
;
ARG_NULL        EQU     11111111b

SI_BYTE 	EQU	0
SI_WORD         EQU     1
SI_DWORD        EQU     2
SI_FWORD        EQU     3
SI_QWORD        EQU     4
SI_TBYTE        EQU     5
SI_NULL         EQU     255

;------------------------------------------------------------
;
; Mnemonic coprocessor instructions reference codes
;
N_F2XM1         EQU     0
N_FABS          EQU     1
N_FADD          EQU     2
N_FIADD         EQU     3
N_FADDP         EQU     4
N_FBLD          EQU     5
N_FBSTP         EQU     6
N_FCHS          EQU     7
N_FCLEX         EQU     8
N_FNCLEX        EQU     9
N_FCOM          EQU     10
N_FCOMP         EQU     11
N_FCOMPP        EQU     12
N_FCOS          EQU     13
N_FDECSTP       EQU     14
N_FDIV          EQU     15
N_FIDIV         EQU     16
N_FDIVP         EQU     17
N_FDIVR         EQU     18
N_FIDIVR        EQU     19
N_FDIVRP        EQU     20
N_FFREE         EQU     21
N_FICOM         EQU     22
;
N_FICOMP        EQU     23
N_FILD          EQU     24
N_FINCSTP       EQU     25
N_FINIT         EQU     26
N_FNINIT        EQU     27
N_FIST          EQU     28
N_FISTP         EQU     29
N_FLD           EQU     30
N_FLD1          EQU     31
N_FLDL2E        EQU     32
N_FLDL2T        EQU     33
N_FLDLG2        EQU     34
N_FLDLN2        EQU     35
N_FLDPI         EQU     36
N_FLDZ          EQU     37
N_FLDCW         EQU     38
N_FLDENV        EQU     39
N_FMUL          EQU     40
N_FIMUL         EQU     41
N_FMULP         EQU     42
N_FNOP          EQU     43
;
N_FPATAN        EQU     44
N_FPREM         EQU     45
N_FPREM1        EQU     46
N_FPTAN         EQU     47
N_FRNDINT       EQU     48
N_FRSTOR        EQU     49
N_FSAVE         EQU     50
N_FNSAVE        EQU     51
N_FSCALE        EQU     52
N_FSIN          EQU     53
N_FSINCOS       EQU     54
N_FSQRT         EQU     55
N_FST           EQU     56
N_FSTCW         EQU     57
N_FNSTCW        EQU     58
N_FSTENV        EQU     59
N_FNSTENV       EQU     60
N_FSTP          EQU     61
N_FSTSW         EQU     62
N_FNSTSW        EQU     63
N_FSTSWAX       EQU     64
N_FNSTSWAX      EQU     65
N_FSUB          EQU     66
;
N_FISUB         EQU     67
N_FSUBP         EQU     68
N_FSUBR         EQU     69
N_FISUBR        EQU     70
N_FSUBRP        EQU     71
N_FTST          EQU     72
N_FUCOM         EQU     73
N_FUCOMP        EQU     74
N_FUCOMPP       EQU     75
N_FXAM          EQU     76
N_FXCH          EQU     77
N_FXTRACT       EQU     78
N_FYL2X         EQU     79
N_FYL2XP1       EQU     80
N_FWAIT         EQU     81
; This 8087/80287 instructions are treated as FNOP by 80387
N_FENI          EQU     82
N_FDISI         EQU     83
N_FSETPM        EQU     84

;------------------------------------------------------------
;
; Control codes
;
;       bits 7,6,5      = unused
;       bits 4,3        = argument type
;       bits 2,1,0      = extra info
;
; When bit 4 = 0 and bit 3 = 0 then bits 2,1,0 of control code
; must match the corresponding opword bits, otherwise it's
; an illegal instruction.
;
CO_STI          EQU     00001000b               ; ST(i)
CO_STSTI        EQU     00010000b               ; ST, ST(i)
CO_STIST        EQU     00011000b               ; ST(i), ST

;------------------------------------------------------------
;
; Mnemonic instructions table
;
; Note:
;       if an instruction has different names depending on operand size
;       (i.e. strings instructions), the names MUST be specified in the
;       following order: [byte], double word, word.
;
TBL_OpNames     LABEL   BYTE
        DB      'aa', _A
        DB      'aa', _D
        DB      'aa', _M
        DB      'aa', _S
        DB      'ad', _C
        DB      'ad', _D
        DB      'an', _D
        DB      'arp', _L
        DB      'boun', _D
        DB      'bs', _F
        DB      'bs', _R
        DB      'b', _T
        DB      'bt', _C
        DB      'bt', _R
        DB      'bt', _S
        DB      'cal', _L
        DB      'cb', _W
        DB      'cd', _Q
        DB      'cl', _C
        DB      'cl', _D
        DB      'cl', _I
        DB      'clt', _S
        DB      'cm', _C
        DB      'cm', _P
        DB      'cmps', _B
        DB      'cmps', _D
        DB      'cmps', _W
        DB      'cw', _D
        DB      'cwd', _E
        DB      'da', _A
        DB      'da', _S
        DB      'de', _C
        DB      'di', _V
        DB      'ente', _R
;
        DB      'hl', _T
        DB      'idi', _V
        DB      'imu', _L
        DB      'i', _N
        DB      'in', _C
        DB      'ins', _B
        DB      'ins', _D
        DB      'ins', _W
        DB      'in', _T
        DB      'int', _O
        DB      'iret', _D
        DB      'ire', _T
        DB      'j', _A
        DB      'ja', _E
        DB      'j', _B
        DB      'jb', _E
        DB      'j', _C
        DB      'jcx', _Z
        DB      'j', _E
        DB      'jecx', _Z
        DB      'j', _G
        DB      'jg', _E
        DB      'j', _L
        DB      'jl', _E
        DB      'jm', _P
        DB      'jn', _C
        DB      'jn', _E
        DB      'jn', _O
        DB      'jn', _P
        DB      'jn', _S
        DB      'j', _O
        DB      'j', _P
        DB      'j', _S
;
        DB      'lah', _F
        DB      'la', _R
        DB      'ld', _S
        DB      'le', _A
        DB      'leav', _E
        DB      'le', _S
        DB      'lf', _S
        DB      'lgd', _T
        DB      'lg', _S
        DB      'lid', _T
        DB      'lld', _T
        DB      'lms', _W
        DB      'loc', _K
        DB      'lods', _B
        DB      'lods', _D
        DB      'lods', _W
        DB      'loo', _P
        DB      'loop', _E
        DB      'loopn', _E
        DB      'ls', _L
        DB      'ls', _S
        DB      'lt', _R
        DB      'mo', _V
        DB      'movs', _B
        DB      'movs', _D
        DB      'movs', _W
        DB      'movs', _X
        DB      'movz', _X
        DB      'mu', _L
        DB      'ne', _G
        DB      'no', _P
        DB      'no', _T
        DB      'o', _R
        DB      'ou', _T
        DB      'outs', _B
        DB      'outs', _D
        DB      'outs', _W
;
        DB      'po', _P
        DB      'popa', _D
        DB      'pop', _A
        DB      'popf', _D
        DB      'pop', _F
        DB      'pus', _H
        DB      'pusha', _D
        DB      'push', _A
        DB      'pushf', _D
        DB      'push', _F
        DB      'rc', _L
        DB      'rc', _R
        DB      're', _P
        DB      'rep', _E
        DB      'repn', _E
        DB      're', _T
        DB      'ro', _L
        DB      'ro', _R
        DB      'sah', _F
        DB      'sa', _R
        DB      'sb', _B
        DB      'scas', _B
        DB      'scas', _D
        DB      'scas', _W
        DB      'set', _A
        DB      'seta', _E
        DB      'set', _B
        DB      'setb', _E
        DB      'set', _C
        DB      'set', _E
        DB      'set', _G
        DB      'setg', _E
        DB      'set', _L
        DB      'setl', _E
        DB      'setn', _C
        DB      'setn', _E
        DB      'setn', _O
        DB      'setn', _P
        DB      'setn', _S
        DB      'set', _O
        DB      'set', _P
        DB      'set', _S
;
        DB      'sgd', _T
        DB      'sh', _L
        DB      'shl', _D
        DB      'sh', _R
        DB      'shr', _D
        DB      'sid', _T
        DB      'sld', _T
        DB      'sms', _W
        DB      'st', _C
        DB      'st', _D
        DB      'st', _I
        DB      'stos', _B
        DB      'stos', _D
        DB      'stos', _W
        DB      'st', _R
        DB      'su', _B
        DB      'tes', _T
        DB      'ver', _R
        DB      'ver', _W
        DB      'wai', _T
        DB      'xch', _G
        DB      'xla', _T
        DB      'xo', _R
;
        DB      'ret', _F
        DB      'd', _B
        DB      'int', TAB, _3
        DB      'loop', _D
        DB      'loopd', _E
        DB      'loopdn', _E
        DB      'loadal', _L    ; Undoc.: load all registers
; New for 486
        DB      'bswa', _P
        DB      'cmpxch', _G
        DB      'inv', _D
        DB      'invlp', _G
        DB      'wbinv', _D
        DB      'xad', _D
; New for Pentium ("cpuid" is supported also by 486DX2s)
        DB      'cpui', _D
        DB      'rdts', _C
        DB      'rdms', _R
        DB      'wrms', _R
        DB      'rs', _M
        DB      'cmpxchg8', _B
;
        DB      'lal', _C       ; Undoc.: CF=0 -> AL=00h, CF=1 -> AL=FFh

;------------------------------------------------------------
;
; Register names
;
TBL_Regs8       LABEL
        DB      'a', _L
        DB      'c', _L
        DB      'd', _L
        DB      'b', _L
        DB      'a', _H
        DB      'c', _H
        DB      'd', _H
        DB      'b', _H
;
TBL_Regs16      LABEL   BYTE
        DB      'a', _X
        DB      'c', _X
        DB      'd', _X
        DB      'b', _X
        DB      's', _P
        DB      'b', _P
        DB      's', _I
        DB      'd', _I
;
TBL_Regs32      LABEL   BYTE
        DB      'ea', _X
        DB      'ec', _X
        DB      'ed', _X
        DB      'eb', _X
        DB      'es', _P
        DB      'eb', _P
        DB      'es', _I
        DB      'ed', _I
;
TBL_RegsS       LABEL   BYTE
        DB      'e', _S
        DB      'c', _S
        DB      's', _S
        DB      'd', _S
        DB      'f', _S
        DB      'g', _S
        DB      '?', _S
        DB      '?', _S

;------------------------------------------------------------
;
; Control registers
;
TBL_RegsC       LABEL   BYTE
        DB      'cr', _0
        DB      '?cr',_1
        DB      'cr', _2
        DB      'cr', _3
        DB      '?cr',_4
        DB      '?cr',_5
        DB      '?cr',_6
        DB      '?cr',_7

;------------------------------------------------------------
;
; Debug registers
;
TBL_RegsD       LABEL   BYTE
        DB      'dr', _0
        DB      'dr', _1
        DB      'dr', _2
        DB      'dr', _3
        DB      '?dr',_4
        DB      '?dr',_5
        DB      'dr', _6
        DB      'dr', _7

;------------------------------------------------------------
;
; Test registers
;
TBL_RegsT       LABEL
        DB      '?tr',_0
        DB      '?tr',_1
        DB      '?tr',_2
        DB      '?tr',_3
        DB      '?tr',_4
        DB      '?tr',_5
        DB      'tr', _6
        DB      'tr', _7

;------------------------------------------------------------
;
; Size specifiers
;
TBL_SizeInfo    LABEL
        DB      'byte ptr', _SPC
        DB      'word ptr', _SPC
        DB      'dword ptr', _SPC
        DB      'fword ptr', _SPC
        DB      'qword ptr', _SPC
        DB      'tbyte ptr', _SPC

;------------------------------------------------------------
;
; 8086 MODRM addressing modes
;
TBL_AddrMode86  LABEL
	DB	'bx+s', _I
	DB	'bx+d', _I
	DB	'bp+s', _I
	DB	'bp+d', _I
	DB	's', _I
	DB	'd', _I
	DB	'b', _P
	DB	'b', _X

;------------------------------------------------------------
;
; Opcode map (1st operand, 2nd operand, name, handler code)
;
TBL_Opcodes     LABEL
; 00h-07h
        DB      AM_E or OT_B,   AM_G or OT_B,   N_ADD,          1
        DB      AM_E or OT_V,   AM_G or OT_V,   N_ADD,          1
        DB      AM_G or OT_B,   AM_E or OT_B,   N_ADD,          1
        DB      AM_G or OT_V,   AM_E or OT_V,   N_ADD,          1
        DB      R_AL,           AM_I or OT_B,   N_ADD,          1
        DB      R_EAX,          AM_I or OT_V,   N_ADD,          1
        DB      R_ES,           ARG_NULL,       N_PUSH,         1
        DB      R_ES,           ARG_NULL,       N_POP,          1
; 08h-0Fh
        DB      AM_E or OT_B,   AM_G or OT_B,   N_OR,           1
        DB      AM_E or OT_V,   AM_G or OT_V,   N_OR,           1
        DB      AM_G or OT_B,   AM_E or OT_B,   N_OR,           1
        DB      AM_G or OT_V,   AM_E or OT_V,   N_OR,           1
        DB      R_AL,           AM_I or OT_B,   N_OR,           1
        DB      R_EAX,          AM_I or OT_V,   N_OR,           1
        DB      R_CS,           ARG_NULL,       N_PUSH,         1
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         10
; 10h-17h
        DB      AM_E or OT_B,   AM_G or OT_B,   N_ADC,          1
        DB      AM_E or OT_V,   AM_G or OT_V,   N_ADC,          1
        DB      AM_G or OT_B,   AM_E or OT_B,   N_ADC,          1
        DB      AM_G or OT_V,   AM_E or OT_V,   N_ADC,          1
        DB      R_AL,           AM_I or OT_B,   N_ADC,          1
        DB      R_EAX,          AM_I or OT_V,   N_ADC,          1
        DB      R_SS,           ARG_NULL,       N_PUSH,         1
        DB      R_SS,           ARG_NULL,       N_POP,          1
; 18h-1Fh
        DB      AM_E or OT_B,   AM_G or OT_B,   N_SBB,          1
        DB      AM_E or OT_V,   AM_G or OT_V,   N_SBB,          1
        DB      AM_G or OT_B,   AM_E or OT_B,   N_SBB,          1
        DB      AM_G or OT_V,   AM_E or OT_V,   N_SBB,          1
        DB      R_AL,           AM_I or OT_B,   N_SBB,          1
        DB      R_EAX,          AM_I or OT_V,   N_SBB,          1
        DB      R_DS,           ARG_NULL,       N_PUSH,         1
        DB      R_DS,           ARG_NULL,       N_POP,          1
; 20h-27h
        DB      AM_E or OT_B,   AM_G or OT_B,   N_AND,          1
        DB      AM_E or OT_V,   AM_G or OT_V,   N_AND,          1
        DB      AM_G or OT_B,   AM_E or OT_B,   N_AND,          1
        DB      AM_G or OT_V,   AM_E or OT_V,   N_AND,          1
        DB      R_AL,           AM_I or OT_B,   N_AND,          1
        DB      R_EAX,          AM_I or OT_V,   N_AND,          1
        DB      R_ES,           ARG_NULL,       N_NULL,         5
        DB      ARG_NULL,       ARG_NULL,       N_DAA,          1
; 28h-2Fh
        DB      AM_E or OT_B,   AM_G or OT_B,   N_SUB,          1
        DB      AM_E or OT_V,   AM_G or OT_V,   N_SUB,          1
        DB      AM_G or OT_B,   AM_E or OT_B,   N_SUB,          1
        DB      AM_G or OT_V,   AM_E or OT_V,   N_SUB,          1
        DB      R_AL,           AM_I or OT_B,   N_SUB,          1
        DB      R_EAX,          AM_I or OT_V,   N_SUB,          1
        DB      R_CS,           ARG_NULL,       N_NULL,         5
        DB      ARG_NULL,       ARG_NULL,       N_DAS,          1
; 30h-37h
        DB      AM_E or OT_B,   AM_G or OT_B,   N_XOR,          1
        DB      AM_E or OT_V,   AM_G or OT_V,   N_XOR,          1
        DB      AM_G or OT_B,   AM_E or OT_B,   N_XOR,          1
        DB      AM_G or OT_V,   AM_E or OT_V,   N_XOR,          1
        DB      R_AL,           AM_I or OT_B,   N_XOR,          1
        DB      R_EAX,          AM_I or OT_V,   N_XOR,          1
        DB      R_SS,           ARG_NULL,       N_NULL,         5
        DB      ARG_NULL,       ARG_NULL,       N_AAA,          1
; 38h-3Fh
        DB      AM_E or OT_B,   AM_G or OT_B,   N_CMP,          1
        DB      AM_E or OT_V,   AM_G or OT_V,   N_CMP,          1
        DB      AM_G or OT_B,   AM_E or OT_B,   N_CMP,          1
        DB      AM_G or OT_V,   AM_E or OT_V,   N_CMP,          1
        DB      R_AL,           AM_I or OT_B,   N_CMP,          1
        DB      R_EAX,          AM_I or OT_V,   N_CMP,          1
        DB      R_DS,           ARG_NULL,       N_NULL,         5
        DB      ARG_NULL,       ARG_NULL,       N_AAS,          1
; 40h-47h
        DB      R_EAX,          ARG_NULL,       N_INC,          1
        DB      R_ECX,          ARG_NULL,       N_INC,          1
        DB      R_EDX,          ARG_NULL,       N_INC,          1
        DB      R_EBX,          ARG_NULL,       N_INC,          1
        DB      R_ESP,          ARG_NULL,       N_INC,          1
        DB      R_EBP,          ARG_NULL,       N_INC,          1
        DB      R_ESI,          ARG_NULL,       N_INC,          1
        DB      R_EDI,          ARG_NULL,       N_INC,          1
; 48h-4Fh
        DB      R_EAX,          ARG_NULL,       N_DEC,          1
        DB      R_ECX,          ARG_NULL,       N_DEC,          1
        DB      R_EDX,          ARG_NULL,       N_DEC,          1
        DB      R_EBX,          ARG_NULL,       N_DEC,          1
        DB      R_ESP,          ARG_NULL,       N_DEC,          1
        DB      R_EBP,          ARG_NULL,       N_DEC,          1
        DB      R_ESI,          ARG_NULL,       N_DEC,          1
        DB      R_EDI,          ARG_NULL,       N_DEC,          1
; 50h-57h
        DB      R_EAX,          ARG_NULL,       N_PUSH,         1
        DB      R_ECX,          ARG_NULL,       N_PUSH,         1
        DB      R_EDX,          ARG_NULL,       N_PUSH,         1
        DB      R_EBX,          ARG_NULL,       N_PUSH,         1
        DB      R_ESP,          ARG_NULL,       N_PUSH,         1
        DB      R_EBP,          ARG_NULL,       N_PUSH,         1
        DB      R_ESI,          ARG_NULL,       N_PUSH,         1
        DB      R_EDI,          ARG_NULL,       N_PUSH,         1
; 58h-5Fh
        DB      R_EAX,          ARG_NULL,       N_POP,          1
        DB      R_ECX,          ARG_NULL,       N_POP,          1
        DB      R_EDX,          ARG_NULL,       N_POP,          1
        DB      R_EBX,          ARG_NULL,       N_POP,          1
        DB      R_ESP,          ARG_NULL,       N_POP,          1
        DB      R_EBP,          ARG_NULL,       N_POP,          1
        DB      R_ESI,          ARG_NULL,       N_POP,          1
        DB      R_EDI,          ARG_NULL,       N_POP,          1
; 60h-67h
        DB      ARG_NULL,       ARG_NULL,       N_PUSHA,        14
        DB      ARG_NULL,       ARG_NULL,       N_POPA,         14
        DB      AM_G or OT_V,   AM_M or OT_V,   N_BOUND,        1
        DB      AM_E or OT_W,   AM_G or OT_W,   N_ARPL,         1
        DB      R_FS,           ARG_NULL,       N_NULL,         5
        DB      R_GS,           ARG_NULL,       N_NULL,         5
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         3
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         2
; 68h-6Fh
        DB      AM_I or OT_V,   ARG_NULL,       N_PUSH,         1
        DB      AM_I or OT_V,   ARG_NULL,       N_IMUL,         6
        DB      AM_I or OT_B,   ARG_NULL,       N_PUSH,         1
        DB      AM_I or OT_B,   ARG_NULL,       N_IMUL,         6
        DB      OT_B,           ARG_NULL,       N_INSB,         8
        DB      OT_V,           ARG_NULL,       N_INSB,         8
        DB      OT_B,           ARG_NULL,       N_OUTSB,        8
        DB      OT_V,           ARG_NULL,       N_OUTSB,        8
; 70h-77h
        DB      AM_J or OT_B,   ARG_NULL,       N_JO,           4
        DB      AM_J or OT_B,   ARG_NULL,       N_JNO,          4
        DB      AM_J or OT_B,   ARG_NULL,       N_JB,           4
        DB      AM_J or OT_B,   ARG_NULL,       N_JAE,          4
        DB      AM_J or OT_B,   ARG_NULL,       N_JE,           4
        DB      AM_J or OT_B,   ARG_NULL,       N_JNE,          4
        DB      AM_J or OT_B,   ARG_NULL,       N_JBE,          4
        DB      AM_J or OT_B,   ARG_NULL,       N_JA,           4
; 78h-7Fh
        DB      AM_J or OT_B,   ARG_NULL,       N_JS,           4
        DB      AM_J or OT_B,   ARG_NULL,       N_JNS,          4
        DB      AM_J or OT_B,   ARG_NULL,       N_JP,           4
        DB      AM_J or OT_B,   ARG_NULL,       N_JNP,          4
        DB      AM_J or OT_B,   ARG_NULL,       N_JL,           4
        DB      AM_J or OT_B,   ARG_NULL,       N_JGE,          4
        DB      AM_J or OT_B,   ARG_NULL,       N_JLE,          4
        DB      AM_J or OT_B,   ARG_NULL,       N_JG,           4
; 80h-87h
        DB      AM_E or OT_B,   AM_I or OT_B,   1,              9
        DB      AM_E or OT_V,   AM_I or OT_V,   1,              9
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         0
        DB      AM_E or OT_V,   AM_I or OT_B,   1,              9
        DB      AM_E or OT_B,   AM_G or OT_B,   N_TEST,         1
        DB      AM_E or OT_V,   AM_G or OT_V,   N_TEST,         1
        DB      AM_G or OT_B,   AM_E or OT_B,   N_XCHG,         1
        DB      AM_G or OT_V,   AM_E or OT_V,   N_XCHG,         1
; 88h-8Fh
        DB      AM_E or OT_B,   AM_G or OT_B,   N_MOV,          1
        DB      AM_E or OT_V,   AM_G or OT_V,   N_MOV,          1
        DB      AM_G or OT_B,   AM_E or OT_B,   N_MOV,          1
        DB      AM_G or OT_V,   AM_E or OT_V,   N_MOV,          1
        DB      AM_E or OT_W,   AM_S or OT_W,   N_MOV,          1
        DB      AM_G or OT_V,   AM_M,           N_LEA,          1
        DB      AM_S or OT_W,   AM_E or OT_W,   N_MOV,          1
        DB      AM_E or OT_V,   ARG_NULL,       N_POP,          1
; 90h-97h
        DB      ARG_NULL,       ARG_NULL,       N_NOP,          1
        DB      R_EAX,          R_ECX,          N_XCHG,         1
        DB      R_EAX,          R_EDX,          N_XCHG,         1
        DB      R_EAX,          R_EBX,          N_XCHG,         1
        DB      R_EAX,          R_ESP,          N_XCHG,         1
        DB      R_EAX,          R_EBP,          N_XCHG,         1
        DB      R_EAX,          R_ESI,          N_XCHG,         1
        DB      R_EAX,          R_EDI,          N_XCHG,         1
; 98h-9Fh
        DB      ARG_NULL,       ARG_NULL,       N_CBW,          14
        DB      ARG_NULL,       ARG_NULL,       N_CWD,          14
        DB      AM_A or OT_P,   ARG_NULL,       N_CALL,         1
        DB      ARG_NULL,       ARG_NULL,       N_WAIT,         1
        DB      ARG_NULL,       ARG_NULL,       N_PUSHF,        14
        DB      ARG_NULL,       ARG_NULL,       N_POPF,         14
        DB      ARG_NULL,       ARG_NULL,       N_SAHF,         1
        DB      ARG_NULL,       ARG_NULL,       N_LAHF,         1
; A0h-A7h
        DB      R_AL,           AM_O or OT_B,   N_MOV,          1
        DB      R_EAX,          AM_O or OT_V,   N_MOV,          1
        DB      AM_O or OT_B,   R_AL,           N_MOV,          1
        DB      AM_O or OT_V,   R_EAX,          N_MOV,          1
        DB      OT_B,           ARG_NULL,       N_MOVSB,        8
        DB      OT_V,           ARG_NULL,       N_MOVSB,        8
        DB      OT_B,           ARG_NULL,       N_CMPSB,        8
        DB      OT_V,           ARG_NULL,       N_CMPSB,        8
; A8h-AFh
        DB      R_AL,           AM_I or OT_B,   N_TEST,         1
        DB      R_EAX,          AM_I or OT_V,   N_TEST,         1
        DB      OT_B,           ARG_NULL,       N_STOSB,        8
        DB      OT_V,           ARG_NULL,       N_STOSB,        8
        DB      OT_B,           ARG_NULL,       N_LODSB,        8
        DB      OT_V,           ARG_NULL,       N_LODSB,        8
        DB      OT_B,           ARG_NULL,       N_SCASB,        8
        DB      OT_V,           ARG_NULL,       N_SCASB,        8
; B0h-B7h
        DB      R_AL,           AM_I or OT_B,   N_MOV,          1
        DB      R_CL,           AM_I or OT_B,   N_MOV,          1
        DB      R_DL,           AM_I or OT_B,   N_MOV,          1
        DB      R_BL,           AM_I or OT_B,   N_MOV,          1
        DB      R_AH,           AM_I or OT_B,   N_MOV,          1
        DB      R_CH,           AM_I or OT_B,   N_MOV,          1
        DB      R_DH,           AM_I or OT_B,   N_MOV,          1
        DB      R_BH,           AM_I or OT_B,   N_MOV,          1
; B8h-BFh
        DB      R_EAX,          AM_I or OT_V,   N_MOV,          1
        DB      R_ECX,          AM_I or OT_V,   N_MOV,          1
        DB      R_EDX,          AM_I or OT_V,   N_MOV,          1
        DB      R_EBX,          AM_I or OT_V,   N_MOV,          1
        DB      R_ESP,          AM_I or OT_V,   N_MOV,          1
        DB      R_EBP,          AM_I or OT_V,   N_MOV,          1
        DB      R_ESI,          AM_I or OT_V,   N_MOV,          1
        DB      R_EDI,          AM_I or OT_V,   N_MOV,          1
; C0h-C7h
        DB      AM_E or OT_B,   AM_I or OT_B,   2,              9
        DB      AM_E or OT_V,   AM_I or OT_B,   2,              9
        DB      AM_I or OT_W,   ARG_NULL,       N_RET,          1
        DB      ARG_NULL,       ARG_NULL,       N_RET,          1
        DB      AM_G or OT_V,   AM_M or OT_P,   N_LES,          1
        DB      AM_G or OT_V,   AM_M or OT_P,   N_LDS,          1
        DB      AM_E or OT_B,   AM_I or OT_B,   N_MOV,          1
        DB      AM_E or OT_V,   AM_I or OT_V,   N_MOV,          1
; C8h-CFh
        DB      AM_I or OT_W,   AM_I or OT_B,   N_ENTER,        1
        DB      ARG_NULL,       ARG_NULL,       N_LEAVE,        1
        DB      AM_I or OT_W,   ARG_NULL,       N_RETF,         1
        DB      ARG_NULL,       ARG_NULL,       N_RETF,         1
        DB      ARG_NULL,       ARG_NULL,       N_INT3,         1
        DB      AM_I or OT_B,   ARG_NULL,       N_INT,          1
        DB      ARG_NULL,       ARG_NULL,       N_INTO,         1
        DB      ARG_NULL,       ARG_NULL,       N_IRET,         14
; D0h-D7h
        DB      AM_E or OT_B,   R_1,            2,              9
        DB      AM_E or OT_V,   R_1,            2,              9
        DB      AM_E or OT_B,   R_CL,           2,              9
        DB      AM_E or OT_V,   R_CL,           2,              9
        DB      AM_I or OT_B,   ARG_NULL,       N_AAM,          13
        DB      AM_I or OT_B,   ARG_NULL,       N_AAD,          13
        DB      ARG_NULL,       ARG_NULL,       N_LALC,         1
        DB      ARG_NULL,       ARG_NULL,       N_XLAT,         1
; D8h-DFh
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         11
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         11
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         11
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         11
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         11
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         11
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         11
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         11
; E0h-E7h
        DB      AM_J or OT_B,   ARG_NULL,       N_LOOPNE,       14
        DB      AM_J or OT_B,   ARG_NULL,       N_LOOPE,        14
        DB      AM_J or OT_B,   ARG_NULL,       N_LOOP,         14
        DB      AM_J or OT_B,   ARG_NULL,       N_JCXZ,         14
        DB      R_AL,           AM_I or OT_B,   N_IN,           1
        DB      R_EAX,          AM_I or OT_B,   N_IN,           1
        DB      AM_I or OT_B,   R_AL,           N_OUT,          1
        DB      AM_I or OT_B,   R_EAX,          N_OUT,          1
; E8h-EFh
        DB      AM_J or OT_V,   ARG_NULL,       N_CALL,         1
        DB      AM_J or OT_V,   ARG_NULL,       N_JMP,          4
        DB      AM_A or OT_P,   ARG_NULL,       N_JMP,          4
        DB      AM_J or OT_B,   ARG_NULL,       N_JMP,          4
        DB      R_AL,           R_DX,           N_IN,           1
        DB      R_EAX,          R_DX,           N_IN,           1
        DB      R_DX,           R_AL,           N_OUT,          1
        DB      R_DX,           R_EAX,          N_OUT,          1
; F0h-F7h
        DB      ARG_NULL,       ARG_NULL,       N_LOCK,         1
        DB      ARG_NULL,       ARG_NULL,       N_NULL,         0
        DB      ARG_NULL,       ARG_NULL,       N_REPNE,        7
        DB      ARG_NULL,       ARG_NULL,       N_REPE,         7
        DB      ARG_NULL,       ARG_NULL,       N_HLT,          1
        DB      ARG_NULL,       ARG_NULL,       N_CMC,          1
        DB      AM_E or OT_B,   ARG_NULL,       3,              9
        DB      AM_E or OT_V,   ARG_NULL,       3,              9
; F8h-FFh
        DB      ARG_NULL,       ARG_NULL,       N_CLC,          1
        DB      ARG_NULL,       ARG_NULL,       N_STC,          1
        DB      ARG_NULL,       ARG_NULL,       N_CLI,          1
        DB      ARG_NULL,       ARG_NULL,       N_STI,          1
        DB      ARG_NULL,       ARG_NULL,       N_CLD,          1
        DB      ARG_NULL,       ARG_NULL,       N_STD,          1
        DB      AM_E or OT_B,   ARG_NULL,       4,              9
        DB      ARG_NULL,       ARG_NULL,       5,              9

;------------------------------------------------------------
;
; Tables of instructions which have different names depending
; on a size prefix (16-bit name, 32-bit name, handler code, prefix)
;
TBL_16to32      LABEL
        DB      N_IRET,         N_IRETD,        1,      PFX_OPERAND32
        DB      N_PUSHF,        N_PUSHFD,       1,      PFX_OPERAND32
        DB      N_PUSHA,        N_PUSHAD,       1,      PFX_OPERAND32
        DB      N_POPF,         N_POPFD,        1,      PFX_OPERAND32
        DB      N_POPA,         N_POPAD,        1,      PFX_OPERAND32
        DB      N_JCXZ,         N_JECXZ,        4,      PFX_ADDRESS32
        DB      N_LOOP,         N_LOOPD,        4,      PFX_ADDRESS32
        DB      N_LOOPE,        N_LOOPDE,       4,      PFX_ADDRESS32
        DB      N_LOOPNE,       N_LOOPDNE,      4,      PFX_ADDRESS32
        DB      N_CWD,          N_CDQ,          1,      PFX_OPERAND32
        DB      N_CBW,          N_CWDE,         1,      PFX_OPERAND32
; End of table
        DB      N_NULL,         N_NULL,         0

;------------------------------------------------------------
;
; Table which enables all opcodes
;
;               FEDCBA9876543210  FEDCBA9876543210
TBL_AllOpcodes          LABEL   BYTE
        DW      1111111111111111b,1111111111111111b     ; 00h-1Fh
        DW      1111111111111111b,1111111111111111b     ; 20h-3Fh
        DW      1111111111111111b,1111111111111111b     ; 40h-5Fh
        DW      1111111111111111b,1111111111111111b     ; 60h-7Fh
        DW      1111111111111111b,1111111111111111b     ; 80h-9Fh
        DW      1111111111111111b,1111111111111111b     ; A0h-BFh
        DW      1111111111111111b,1111111111111111b     ; C0h-DFh
        DW      1111111111111111b,1111111111111111b     ; E0h-FFh

;------------------------------------------------------------
;
; Table for specific 8086 opcodes support
;
;               FEDCBA9876543210  FEDCBA9876543210
TBL_8086Opcodes         LABEL   BYTE
        DW      0111111111111111b,1111111111111111b     ; 00h-1Fh
        DW      1111111111111111b,1111111111111111b     ; 20h-3Fh
        DW      1111111111111111b,1111111111111111b     ; 40h-5Fh
        DW      0000000000000000b,1111111111111111b     ; 60h-7Fh
        DW      1111111111111111b,1111111111111111b     ; 80h-9Fh
        DW      1111111111111111b,1111111111111111b     ; A0h-BFh
        DW      1111110011111100b,1111111110111111b     ; C0h-DFh
        DW      1111111111111111b,1111111111111101b     ; E0h-FFh

;------------------------------------------------------------
;
; Table for specific 80186 opcodes support:
; pusha, popa, bound, ins, outs, enter and leave are new;
; push, rol...shr and imul have been extended to immediate data.
;
;               FEDCBA9876543210  FEDCBA9876543210
TBL_80186Opcodes        LABEL   BYTE
        DW      0111111111111111b,1111111111111111b     ; 00h-1Fh
        DW      1111111111111111b,1111111111111111b     ; 20h-3Fh
        DW      1111111111111111b,1111111111111111b     ; 40h-5Fh
        DW      1111111100000111b,1111111111111111b     ; 60h-7Fh
        DW      1111111111111111b,1111111111111111b     ; 80h-9Fh
        DW      1111111111111111b,1111111111111111b     ; A0h-BFh
        DW      1111111111111111b,1111111110111111b     ; C0h-DFh
        DW      1111111111111111b,1111111111111101b     ; E0h-FFh

;------------------------------------------------------------
;
; Two-byte opcodes table (0Fh, opcode, 1st operand, 2nd operand, ...)
;
TBL_Opcodes2    LABEL
  DB    00h,    ARG_NULL,       ARG_NULL,       6,              9
  DB    01h,    ARG_NULL,       ARG_NULL,       7,              9
  DB    02h,    AM_G or OT_V,   AM_E or OT_W,   N_LAR,          1
  DB    03h,    AM_G or OT_V,   AM_E or OT_W,   N_LSL,          1
  DB    05h,    ARG_NULL,       ARG_NULL,       N_LOADALL,      1   ; 286
  DB    06h,    ARG_NULL,       ARG_NULL,       N_CLTS,         1
; DB    07h,    ARG_NULL,       ARG_NULL,       N_LOADALL,      1   ; 386,486
  DB    08h,    ARG_NULL,       ARG_NULL,       N_INVD,         1   ; 486
  DB    09h,    ARG_NULL,       ARG_NULL,       N_WBINVD,       1   ; 486
  DB    20h,    AM_R or OT_D,   AM_C or OT_D,   N_MOV,          1
  DB    21h,    AM_R or OT_D,   AM_D or OT_D,   N_MOV,          1
  DB    22h,    AM_C or OT_D,   AM_R or OT_D,   N_MOV,          1
  DB    23h,    AM_D or OT_D,   AM_R or OT_D,   N_MOV,          1
  DB    24h,    AM_T or OT_D,   AM_R or OT_D,   N_MOV,          1
  DB    26h,    AM_R or OT_D,   AM_T or OT_D,   N_MOV,          1
  DB    30h,    ARG_NULL,       ARG_NULL,       N_WRMSR,        1   ; Pentium
  DB    31h,    ARG_NULL,       ARG_NULL,       N_RDTSC,        1   ; Pentium
  DB    32h,    ARG_NULL,       ARG_NULL,       N_RDMSR,        1   ; Pentium
  DB    80h,    AM_J or OT_V,   ARG_NULL,       N_JO,           4
  DB    81h,    AM_J or OT_V,   ARG_NULL,       N_JNO,          4
  DB    82h,    AM_J or OT_V,   ARG_NULL,       N_JB,           4
  DB    83h,    AM_J or OT_V,   ARG_NULL,       N_JAE,          4
  DB    84h,    AM_J or OT_V,   ARG_NULL,       N_JE,           4
  DB    85h,    AM_J or OT_V,   ARG_NULL,       N_JNE,          4
  DB    86h,    AM_J or OT_V,   ARG_NULL,       N_JBE,          4
  DB    87h,    AM_J or OT_V,   ARG_NULL,       N_JA,           4
  DB    88h,    AM_J or OT_V,   ARG_NULL,       N_JS,           4
  DB    89h,    AM_J or OT_V,   ARG_NULL,       N_JNS,          4
  DB    8Ah,    AM_J or OT_V,   ARG_NULL,       N_JP,           4
  DB    8Bh,    AM_J or OT_V,   ARG_NULL,       N_JNP,          4
  DB    8Ch,    AM_J or OT_V,   ARG_NULL,       N_JL,           4
  DB    8Dh,    AM_J or OT_V,   ARG_NULL,       N_JGE,          4
  DB    8Eh,    AM_J or OT_V,   ARG_NULL,       N_JLE,          4
  DB    8Fh,    AM_J or OT_V,   ARG_NULL,       N_JG,           4
  DB    90h,    AM_E or OT_B,   ARG_NULL,       N_SETO,         1
  DB    91h,    AM_E or OT_B,   ARG_NULL,       N_SETNO,        1
  DB    92h,    AM_E or OT_B,   ARG_NULL,       N_SETB,         1
  DB    93h,    AM_E or OT_B,   ARG_NULL,       N_SETAE,        1
  DB    94h,    AM_E or OT_B,   ARG_NULL,       N_SETE,         1
  DB    95h,    AM_E or OT_B,   ARG_NULL,       N_SETNE,        1
  DB    96h,    AM_E or OT_B,   ARG_NULL,       N_SETBE,        1
  DB    97h,    AM_E or OT_B,   ARG_NULL,       N_SETA,         1
  DB    98h,    AM_E or OT_B,   ARG_NULL,       N_SETS,         1
  DB    99h,    AM_E or OT_B,   ARG_NULL,       N_SETNS,        1
  DB    9Ah,    AM_E or OT_B,   ARG_NULL,       N_SETP,         1
  DB    9Bh,    AM_E or OT_B,   ARG_NULL,       N_SETNP,        1
  DB    9Ch,    AM_E or OT_B,   ARG_NULL,       N_SETL,         1
  DB    9Dh,    AM_E or OT_B,   ARG_NULL,       N_SETGE,        1
  DB    9Eh,    AM_E or OT_B,   ARG_NULL,       N_SETLE,        1
  DB    9Fh,    AM_E or OT_B,   ARG_NULL,       N_SETG,         1
  DB   0A0h,    R_FS,           ARG_NULL,       N_PUSH,         1
  DB   0A1h,    R_FS,           ARG_NULL,       N_POP,          1
  DB   0A2h,    ARG_NULL,       ARG_NULL,       N_CPUID,        1   ; Pentium
  DB   0A3h,    AM_E or OT_V,   AM_G or OT_V,   N_BT,           1
  DB   0A4h,    AM_I or OT_B,   ARG_NULL,       N_SHLD,         12
  DB   0A5h,    R_CL,           ARG_NULL,       N_SHLD,         12
  DB   0A6h,    AM_E or OT_B,   AM_G or OT_B,   N_CMPXCHG,      1   ; 486
  DB   0A7h,    AM_E or OT_V,   AM_G or OT_V,   N_CMPXCHG,      1   ; 486
  DB   0A8h,    R_GS,           ARG_NULL,       N_PUSH,         1
  DB   0A9h,    R_GS,           ARG_NULL,       N_POP,          1
  DB   0AAh,    ARG_NULL,       ARG_NULL,       N_RSM,          1   ; Pentium
  DB   0ABh,    AM_E or OT_V,   AM_G or OT_V,   N_BTS,          1
  DB   0ACh,    AM_I or OT_B,   ARG_NULL,       N_SHRD,         12
  DB   0ADh,    R_CL,           ARG_NULL,       N_SHRD,         12
  DB   0AFh,    AM_G or OT_V,   AM_E or OT_V,   N_IMUL,         1
  DB   0B2h,    AM_M or OT_P,   ARG_NULL,       N_LSS,          1
  DB   0B3h,    AM_E or OT_V,   AM_G or OT_V,   N_BTR,          1
  DB   0B4h,    AM_M or OT_P,   ARG_NULL,       N_LFS,          1
  DB   0B5h,    AM_M or OT_P,   ARG_NULL,       N_LGS,          1
  DB   0B6h,    AM_G or OT_V,   AM_E or OT_B,   N_MOVZX,        1
  DB   0B7h,    AM_G or OT_V,   AM_E or OT_W,   N_MOVZX,        1
  DB   0BAh,    AM_E or OT_V,   AM_I or OT_B,   8,              9
  DB   0BBh,    AM_E or OT_V,   AM_G or OT_V,   N_BTC,          1
  DB   0BCh,    AM_G or OT_V,   AM_E or OT_V,   N_BSF,          1
  DB   0BDh,    AM_G or OT_V,   AM_E or OT_V,   N_BSR,          1
  DB   0BEh,    AM_G or OT_V,   AM_E or OT_B,   N_MOVSX,        1
  DB   0BFh,    AM_G or OT_V,   AM_E or OT_W,   N_MOVSX,        1
  DB   0C0h,    AM_E or OT_B,   AM_G or OT_B,   N_XADD,         1   ; 486
  DB   0C1h,    AM_E or OT_V,   AM_G or OT_V,   N_XADD,         1   ; 486
  DB   0C7h,    AM_M or OT_Q,   ARG_NULL,       N_CMPXCHG8B,    1   ; Pentium
  DB   0C8h,    R_EAX,          ARG_NULL,       N_BSWAP,        1   ; 486
  DB   0C9h,    R_ECX,          ARG_NULL,       N_BSWAP,        1   ; 486
  DB   0CAh,    R_EDX,          ARG_NULL,       N_BSWAP,        1   ; 486
  DB   0CBh,    R_EBX,          ARG_NULL,       N_BSWAP,        1   ; 486
  DB   0CCh,    R_ESP,          ARG_NULL,       N_BSWAP,        1   ; 486
  DB   0CDh,    R_EBP,          ARG_NULL,       N_BSWAP,        1   ; 486
  DB   0CEh,    R_ESI,          ARG_NULL,       N_BSWAP,        1   ; 486
  DB   0CFh,    R_EDI,          ARG_NULL,       N_BSWAP,        1   ; 486
TBL_Opcodes2End LABEL

;------------------------------------------------------------
;
; Opcodes determined by bits 5,4,3 of MODRM field
;
TBL_Groups      LABEL   BYTE
DB      N_ADD,  N_OR,   N_ADC,  N_SBB,  N_AND,  N_SUB,  N_XOR,  N_CMP
DB      N_ROL,  N_ROR,  N_RCL,  N_RCR,  N_SHL,  N_SHR,  N_NULL, N_SAR
DB      N_TEST, N_NULL, N_NOT,  N_NEG,  N_MUL,  N_IMUL, N_DIV,  N_IDIV
DB      N_INC,  N_DEC,  N_NULL, N_NULL, N_NULL, N_NULL, N_NULL, N_NULL
DB      N_INC,  N_DEC,  N_CALL, N_CALL, N_JMP,  N_JMP,  N_PUSH, N_NULL
DB      N_SLDT, N_STR,  N_LLDT, N_LTR,  N_VERR, N_VERW, N_NULL, N_NULL
DB      N_SGDT, N_SIDT, N_LGDT, N_LIDT, N_SMSW, N_NULL, N_LMSW, N_INVLPG
DB      N_NULL, N_NULL, N_NULL, N_NULL, N_BT,   N_BTS,  N_BTR,  N_BTC

;------------------------------------------------------------
;
; 1st or 2nd argument for some of the above groups
;
TBL_Grp5Arg     LABEL   BYTE
        DB      AM_E or OT_V
        DB      AM_E or OT_V
        DB      AM_E or OT_V
        DB      AM_E or OT_P
        DB      AM_E or OT_V
        DB      AM_E or OT_P
        DB      AM_E or OT_V
        DB      ARG_NULL

TBL_Grp7Arg     LABEL   BYTE
        DB      AM_M or OT_S
        DB      AM_M or OT_S
        DB      AM_M or OT_S
        DB      AM_M or OT_S
        DB      AM_E or OT_W
        DB      ARG_NULL
        DB      AM_E or OT_W
        DB      AM_M or OT_S

;------------------------------------------------------------
;
; Mnemonic coprocessor instructions table
;
; Note: the first char (always 'f') is not reported.
;
TBL_CopNames    LABEL   BYTE
        DB      '2xm', _1
        DB      'ab', _S
        DB      'ad', _D
        DB      'iad', _D
        DB      'add', _P
        DB      'bl', _D
        DB      'bst', _P
        DB      'ch', _S
        DB      'cle', _X
        DB      'ncle', _X
        DB      'co', _M
        DB      'com', _P
        DB      'comp', _P
        DB      'co', _S
        DB      'decst', _P
        DB      'di', _V
        DB      'idi', _V
        DB      'div', _P
        DB      'div', _R
        DB      'idiv', _R
        DB      'divr', _P
        DB      'fre', _E
        DB      'ico', _M
;
        DB      'icom', _P
        DB      'il', _D
        DB      'incst', _P
        DB      'ini', _T
        DB      'nini', _T
        DB      'is', _T
        DB      'ist', _P
        DB      'l', _D
        DB      'ld', _1
        DB      'ldl2', _E
        DB      'ldl2', _T
        DB      'ldlg', _2
        DB      'ldln', _2
        DB      'ldp', _I
        DB      'ld', _Z
        DB      'ldc', _W
        DB      'lden', _V
        DB      'mu', _L
        DB      'imu', _L
        DB      'mul', _P
        DB      'no', _P
;
        DB      'pata', _N
        DB      'pre', _M
        DB      'prem', _1
        DB      'pta', _N
        DB      'rndin', _T
        DB      'rsto', _R
        DB      'sav', _E
        DB      'nsav', _E
        DB      'scal', _E
        DB      'si', _N
        DB      'sinco', _S
        DB      'sqr', _T
        DB      's', _T
        DB      'stc', _W
        DB      'nstc', _W
        DB      'sten', _V
        DB      'nsten', _V
        DB      'st', _P
        DB      'sts', _W
        DB      'nsts', _W
        DB      'stsw', TAB, 'a', _X
        DB      'nstsw', TAB, 'a', _X
        DB      'su', _B
;
        DB      'isu', _B
        DB      'sub', _P
        DB      'sub', _R
        DB      'isub', _R
        DB      'subr', _P
        DB      'ts', _T
        DB      'uco', _M
        DB      'ucom', _P
        DB      'ucomp', _P
        DB      'xa', _M
        DB      'xc', _H
        DB      'xtrac', _T
        DB      'yl2', _X
        DB      'yl2xp', _1
        DB      'wai', _T
;
        DB      'en', _I
        DB      'dis', _I
        DB      'setp', _M

;------------------------------------------------------------
;
; Table of 80387 instructions not valid for 8087/80287
;
TBL_No80287     LABEL
        DB      N_FUCOM
        DB      N_FUCOMP
        DB      N_FUCOMPP
        DB      N_FPREM1
        DB      N_FCOS
        DB      N_FSIN
        DB      N_FSINCOS

;------------------------------------------------------------
; Argument is a standard MODRM byte/word, the argument size
; follows the instruction name
TBL_Cop1        LABEL
        DB      N_FLDENV,       SI_NULL
        DB      N_FLDCW,        SI_NULL
        DB      N_FSTENV,       SI_NULL
        DB      N_FSTCW,        SI_NULL
        DB      N_NULL,         SI_NULL
        DB      N_FLD,          SI_TBYTE
        DB      N_NULL,         SI_NULL
        DB      N_FSTP,         SI_TBYTE
        DB      N_FRSTOR,       SI_NULL
        DB      N_NULL,         SI_NULL
        DB      N_FSAVE,        SI_NULL
        DB      N_FSTSW,        SI_NULL
        DB      N_FBLD,         SI_TBYTE
        DB      N_FILD,         SI_QWORD
        DB      N_FBSTP,        SI_TBYTE
        DB      N_FISTP,        SI_QWORD
;------------------------------------------------------------
; Argument is a standard MODRM byte/word, the argument size is
; stored into the opcode itself
TBL_Cop2        LABEL
        DB      N_FADD
        DB      N_FMUL
        DB      N_FCOM
        DB      N_FCOMP
        DB      N_FSUB
        DB      N_FSUBR
        DB      N_FDIV
        DB      N_FDIVR
        DB      N_FLD
        DB      N_NULL
        DB      N_FST
        DB      N_FSTP
; Integer version of above instructions
        DB      N_FIADD
        DB      N_FIMUL
        DB      N_FICOM
        DB      N_FICOMP
        DB      N_FISUB
        DB      N_FISUBR
        DB      N_FIDIV
        DB      N_FIDIVR
        DB      N_FILD
        DB      N_NULL
        DB      N_FIST
        DB      N_FISTP
;------------------------------------------------------------
; Arguments are stored in a special byte, see below for
; definitions
TBL_Cop300      LABEL
        DB      N_FADD,         CO_STSTI
        DB      N_FMUL,         CO_STSTI
        DB      N_FCOM,         CO_STI
        DB      N_FCOMP,        CO_STI
        DB      N_FSUB,         CO_STSTI
        DB      N_FSUBR,        CO_STSTI
        DB      N_FDIV,         CO_STSTI
        DB      N_FDIVR,        CO_STSTI
        DB      N_FLD,          CO_STI
        DB      N_FXCH,         CO_STI
        DB      N_FNOP,         000b
        DB      N_FSTP,         CO_STI
TBL_Cop301      LABEL
; Group 3.01 contains only one opcode, which is handled apart
TBL_Cop310      LABEL
        DB      N_FADD,         CO_STIST
        DB      N_FMUL,         CO_STIST
        DB      N_FCOM,         CO_STI
        DB      N_FCOMP,        CO_STI
        DB      N_FSUBR,        CO_STIST
        DB      N_FSUB,         CO_STIST
        DB      N_FDIVR,        CO_STIST
        DB      N_FDIV,         CO_STIST
        DB      N_FFREE,        CO_STI
        DB      N_FXCH,         CO_STI
        DB      N_FST,          CO_STI
        DB      N_FSTP,         CO_STI
        DB      N_FUCOM,        CO_STI
        DB      N_FUCOMP,       CO_STI
        DB      N_NULL,         0
        DB      N_NULL,         0
TBL_Cop311      LABEL
        DB      N_FADDP,        CO_STIST
        DB      N_FMULP,        CO_STIST
        DB      N_FCOMP,        CO_STI
        DB      N_FCOMPP,       001b
        DB      N_FSUBP,        CO_STIST
        DB      N_FSUBRP,       CO_STIST
        DB      N_FDIVP,        CO_STIST
        DB      N_FDIVRP,       CO_STIST
        DB      N_FFREE,        CO_STI
        DB      N_FXCH,         CO_STI
        DB      N_FSTP,         CO_STI
        DB      N_FSTP,         CO_STI
        DB      N_FSTSWAX,      000b
        DB      N_NULL,         0
        DB      N_NULL,         0
        DB      N_NULL,         0
;------------------------------------------------------------
; No arguments for these instructions
TBL_Cop4        LABEL
        DB      N_FCHS
        DB      N_FABS
        DB      N_NULL
        DB      N_NULL
        DB      N_FTST
        DB      N_FXAM
        DB      N_NULL
        DB      N_NULL
        DB      N_FLD1
        DB      N_FLDL2T
        DB      N_FLDL2E
        DB      N_FLDPI
        DB      N_FLDLG2
        DB      N_FLDLN2
        DB      N_FLDZ
        DB      N_NULL
        DB      N_F2XM1
        DB      N_FYL2X
        DB      N_FPTAN
        DB      N_FPATAN
        DB      N_FXTRACT
        DB      N_FPREM1
        DB      N_FDECSTP
        DB      N_FINCSTP
        DB      N_FPREM
        DB      N_FYL2XP1
        DB      N_FSQRT
        DB      N_FSINCOS
        DB      N_FRNDINT
        DB      N_FSCALE
        DB      N_FSIN
        DB      N_FCOS
;
        DB      N_FENI
        DB      N_FDISI
        DB      N_FCLEX
        DB      N_FINIT
        DB      N_FSETPM
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
        DB      N_NULL
